"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Database = void 0;
const knex_1 = __importDefault(require("knex"));
const ramda_1 = __importDefault(require("ramda"));
const objection_1 = require("objection");
const table_constant_1 = require("./table.constant");
const dotenv = __importStar(require("dotenv"));
const users_json_1 = require("./data/users.json");
dotenv.config();
class Database {
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    constructor() { }
    static getInstance() {
        return __awaiter(this, void 0, void 0, function* () {
            if (ramda_1.default.isNil(this._knexInstance)) {
                this._knexInstance = (0, knex_1.default)({
                    client: 'pg',
                    connection: process.env.DB_URL,
                });
                objection_1.Model.knex(this._knexInstance);
                return this._knexInstance;
            }
            else {
                return this._knexInstance;
            }
        });
    }
    static initSchema() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            if (yield ((_a = (yield this.getInstance())) === null || _a === void 0 ? void 0 : _a.schema.hasTable(table_constant_1.TABLES.USER))) {
                return;
            }
            yield ((_b = (yield this.getInstance())) === null || _b === void 0 ? void 0 : _b.schema.createTable(table_constant_1.TABLES.USER, (table) => {
                table.increments('id');
                table.string('name');
                table.integer('age');
            }));
        });
    }
    static seed() {
        var _a, _b, _c, _d;
        return __awaiter(this, void 0, void 0, function* () {
            yield ((_b = (_a = (yield this.getInstance())) === null || _a === void 0 ? void 0 : _a.table(table_constant_1.TABLES.USER)) === null || _b === void 0 ? void 0 : _b.truncate());
            yield ((_d = (_c = (yield this.getInstance())) === null || _c === void 0 ? void 0 : _c.table(table_constant_1.TABLES.USER)) === null || _d === void 0 ? void 0 : _d.insert(users_json_1.users));
        });
    }
    static init() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.initSchema();
            yield this.seed();
        });
    }
    static teardown() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            yield ((_a = (yield this.getInstance())) === null || _a === void 0 ? void 0 : _a.destroy());
        });
    }
}
exports.Database = Database;
Database._knexInstance = null;
